<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch">
      <el-form-item label="号口名称" prop="useNoName">
        <el-input
          v-model="queryParams.useNoName"
          placeholder="请输入号口名称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="指令：开" prop="commandOpen">
        <el-input
          v-model="queryParams.commandOpen"
          placeholder="请输入指令：开"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="指令：关" prop="commandClose">
        <el-input
          v-model="queryParams.commandClose"
          placeholder="请输入指令：关"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['control:useNoConfig:add']"
        >新增
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['control:useNoConfig:edit']"
        >修改
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['control:useNoConfig:remove']"
        >删除
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          :loading="exportLoading"
          @click="handleExport"
          v-hasPermi="['control:useNoConfig:export']"
        >导出
        </el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="useNoConfigList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center"/>
      <el-table-column label="号口名称" align="center" prop="useNoName"/>
      <el-table-column label="指令：开" align="center" prop="commandOpen"/>
      <el-table-column label="指令：关" align="center" prop="commandClose"/>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['control:useNoConfig:edit']"
          >修改
          </el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['control:useNoConfig:remove']"
          >删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改空开设备号口配置对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="600px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules">
        <el-form-item label="号口名称" prop="useNoName">
          <el-input v-model="form.useNoName" placeholder="请输入号口名称"/>
        </el-form-item>
        <el-form-item label="指令：开" prop="commandOpen">
          <el-input v-model="form.commandOpen" placeholder="请输入指令：开"/>
        </el-form-item>
        <el-form-item label="指令：关" prop="commandClose">
          <el-input v-model="form.commandClose" placeholder="请输入指令：关"/>
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark" placeholder="请输入备注"/>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
  import {
    addUseNoConfig,
    delUseNoConfig,
    exportUseNoConfig,
    getUseNoConfig,
    listUseNoConfig,
    updateUseNoConfig
  } from "@/api/control/useNoConfig";

  export default {
    name: "UseNoConfig",
    props: {
      useNoDeviceId: {
        type: [String],
        default: null
      }
    },
    data() {
      return {
        // 遮罩层
        loading: true,
        // 导出遮罩层
        exportLoading: false,
        // 选中数组
        ids: [],
        // 非单个禁用
        single: true,
        // 非多个禁用
        multiple: true,
        // 显示搜索条件
        showSearch: true,
        // 总条数
        total: 0,
        // 空开设备号口配置表格数据
        useNoConfigList: [],
        // 弹出层标题
        title: "",
        // 是否显示弹出层
        open: false,
        // 查询参数
        queryParams: {
          pageNum: 1,
          pageSize: 10,
          deviceId: null,
          useNoName: null,
          commandDefault: null,
          commandOpen: null,
          commandClose: null,
          isDelete: null,
        },
        // 表单参数
        form: {},
        // 表单校验
        rules: {}
      };
    },
    created() {
      this.getList();
    },
    show() {},
    methods: {
      /** 查询空开设备号口配置列表 */
      getList() {
        this.queryParams.deviceId = this.useNoDeviceId;
        this.loading = true;
        listUseNoConfig(this.queryParams).then(response => {
          this.useNoConfigList = response.rows;
          this.total = response.total;
          this.loading = false;
        });
      },
      // 取消按钮
      cancel() {
        this.open = false;
        this.reset();
      },
      // 表单重置
      reset() {
        this.form = {
          useNoId: null,
          deviceId: null,
          useNoName: null,
          commandDefault: null,
          commandOpen: null,
          commandClose: null,
          isDelete: null,
          createBy: null,
          createTime: null,
          updateBy: null,
          updateTime: null,
          remark: null
        };
        this.resetForm("form");
      },
      /** 搜索按钮操作 */
      handleQuery() {
        this.queryParams.pageNum = 1;
        this.getList();
      },
      /** 重置按钮操作 */
      resetQuery() {
        this.resetForm("queryForm");
        this.handleQuery();
      },
      // 多选框选中数据
      handleSelectionChange(selection) {
        this.ids = selection.map(item => item.useNoId)
        this.single = selection.length !== 1
        this.multiple = !selection.length
      },
      /** 新增按钮操作 */
      handleAdd() {
        this.reset();
        this.open = true;
        this.title = "添加空开设备号口配置";
      },
      /** 修改按钮操作 */
      handleUpdate(row) {
        this.reset();
        const useNoId = row.useNoId || this.ids
        getUseNoConfig(useNoId).then(response => {
          this.form = response.data;
          this.open = true;
          this.title = "修改空开设备号口配置";
        });
      },
      /** 提交按钮 */
      submitForm() {
        this.$refs["form"].validate(valid => {
          this.form.deviceId = this.useNoDeviceId
          if (valid) {
            if (this.form.useNoId != null) {
              updateUseNoConfig(this.form).then(response => {
                this.$modal.msgSuccess("修改成功");
                this.open = false;
                this.getList();
              });
            } else {
              addUseNoConfig(this.form).then(response => {
                this.$modal.msgSuccess("新增成功");
                this.open = false;
                this.getList();
              });
            }
          }
        });
      },
      /** 删除按钮操作 */
      handleDelete(row) {
        const useNoIds = row.useNoId || this.ids;
        this.$modal.confirm('是否确认删除空开设备号口配置编号为"' + useNoIds + '"的数据项？').then(function () {
          return delUseNoConfig(useNoIds);
        }).then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        }).catch(() => {
        });
      },
      /** 导出按钮操作 */
      handleExport() {
        const queryParams = this.queryParams;
        this.$modal.confirm('是否确认导出所有空开设备号口配置数据项？').then(() => {
          this.exportLoading = true;
          return exportUseNoConfig(queryParams);
        }).then(response => {
          this.$download.name(response.msg);
          this.exportLoading = false;
        }).catch(() => {
        });
      }
    }
  };
</script>
